#!/bin/sh
#/opt/local/bin/ramdisk-2thirds.sh
# Goal: Create a ramdisk out of 2/3 of the free RAM of a Puppy system at startup.
#
# Original by Pizza'sGood ramdisk_gui, 27 Dec. 2001.
# Source : http://murga-linux.com/puppy/viewtopic.php?p=592060&sort=lastpost#592060
# (retrieved Oct. 14 2017).
#
# New parts: © Christian L'Écuyer, Gatineau (Qc), Canada, Oct. 14-15 2017. GPL3
# (Alias musher0 [forum Puppy].) # https://opensource.org/licenses/GPL-3.0
#################
#   	This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#		This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#    	You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
##########
####
ChecK="`df | awk '$NF ~ /ram1/'`" # musher0, 17-10-14
if [ "$ChecK" = "" ];then # musher0, 17-10-14
	MOUNTPOINT="/mnt/ram1"
#	SIZE="`free -m | awk '/Mem/ {print $4/3*2}'`"
	LC_ALL=C;SIZE="`free -m | awk '/Mem/ {print $4/3*2}'`";LC_ALL=""
	SIZE="${SIZE%.*}" #	[ "`echo $[ $SIZE % 2]`" != "0" ]
	# Laisser tomber les décimales possibles.

	mkdir -p "$MOUNTPOINT" # make sure the mountpoint exists
	mount -t tmpfs -o size="${SIZE}"m tmpfs "$MOUNTPOINT" # mount the ramdisk
	sleep 0.5s

	MsG="A $SIZE Mb ramdisk has been created."
	Xdialog --title "Created" --ok-label "OK" --timeout 5 --msgbox "$MsG" 0 0

	rox /mnt/ram1 &

	exec /opt/local/bin/ramdisk_cp.sh & # Copy contents of /mnt/home/ramdisk, if any.

else # This section by musher0, 17-10-14
	Xdialog --title "Exists" --ok-label "OK" --timeout 5 --msgbox "A ramdisk already exists." 0 0
fi # End of section by musher0, 17-10-14

########## Reference ####
# Add-ins by musher0
# Various one-liners to do checks on this ramdisk.
# 1a) # echo -e "Location\tUsed\tAvail.\t%\tName";df -h | awk '$NF ~ /ramdisk/ { print $1"\t\t"$3"\t"$4"\t"$5"\t"$6}'
# OR
# 1b) echo;df | head -1;df | grep ramdisk
# The above lines will tell you the size and occupancy.
#
##
# 2) df | head -1;df | grep ram
#
# 3) df | awk '$2=="1024000" && $NF ~ /ramdisk/'
# These two just tell you if there is a "ramdisk".
####
